package com.steerinfo.baseinfo.meterbasedriver.controller;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.steerinfo.baseinfo.meterbasecar.mapper.MeterBaseCarMapper;
import com.steerinfo.baseinfo.meterbasecar.model.MeterBaseCar;
import com.steerinfo.baseinfo.meterbasecussupcar.model.MeterBaseCusSupCar;
import com.steerinfo.baseinfo.meterbasedriver.mapper.MeterBaseDriverMapper;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.user.UserPayload;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbasedriver.model.MeterBaseDriver;
import com.steerinfo.baseinfo.meterbasedriver.service.IMeterBaseDriverService;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.util.StringUtils;
import feign.Param;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import io.swagger.models.auth.In;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.*;
import java.math.BigDecimal;

/**
 * MeterBaseDriver RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-01-10 03:09
 * 类描述
 * 修订历史：
 * 日期：2022-01-10
 * 作者：generator
 * 参考：
 * 描述：MeterBaseDriver RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterbasedrivers")
@Api(value = "/${api.version}/meterbasedrivers", tags = "司机信息 - MeterBaseDriverController")
public class MeterBaseDriverController extends BaseRESTfulController {

    @Autowired
    IMeterBaseDriverService meterBaseDriverService;

    @Resource
    MeterBaseDriverMapper meterBaseDriverMapper;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasedriver:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseDriver> list = meterBaseDriverService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasedriver:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseDriver> list = meterBaseDriverService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    @PostMapping(value = "/like/")
    public RESTfulResult listLikepost(@RequestBody HashMap parmas){
        Integer pageNum = parmas.get("pageNum") == null ? 1 : Integer.parseInt(parmas.get("pageNum").toString());
        Integer pageSize = parmas.get("pageSize") == null ? 20 : Integer.parseInt(parmas.get("pageSize").toString());
        PageList<MeterBaseDriver> list = meterBaseDriverService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterBaseDriver对象创建")
    @ApiImplicitParam(name = "meterBaseDriver", value = "详细实体meterBaseDriver", required = true, dataType = "MeterBaseDriver")
    @Transactional
    //@RequiresPermissions("meterbasedriver:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterBaseDriver model){

        try {
            String msg = meterBaseDriverService.checkandadd(model);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasedriver:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterBaseDriver meterBaseDriver = meterBaseDriverService.getById(id);
        return success(meterBaseDriver);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBaseDriver信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterBaseDriver", value = "详细实体meterBaseDriver", required = true, dataType = "MeterBaseDriver")
    })
    //@RequiresPermissions("meterbasedriver:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseDriver model){
        model.setId(id);
        MeterBaseDriver meterBaseDriver = meterBaseDriverService.modify(model);
        return success(meterBaseDriver);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasedriver:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterBaseDriverService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="批量删除", notes="根据list删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasedriver:delete")
    @PutMapping(value = "/deleteBatch")//String
    public RESTfulResult deleteBatch(@RequestBody List<MeterBaseDriver> model){
        try {
            List<String> list = new ArrayList<>();
            for(MeterBaseDriver models : model){
                list.add(models.getDriverNo());
            }
            meterBaseDriverMapper.deleteDriverById(list);
            return success();
        }
        catch (Exception e){
            e.printStackTrace();
            return failed(null,"操作异常，请确认");
        }
    }

    @ApiOperation(value = "根据司机直接废除", notes = "根据url的id来指定删除对象")
    //@RequiresPermissions("meterbasecar:delete")
    @PostMapping(value = "/deleteByDriverNo")//String
    public RESTfulResult deleteByCarNo(@RequestBody Map driverNo) {
        try {
            List<String> list = new ArrayList<>();
            list.add(driverNo.get("driverNo").toString());
            meterBaseDriverMapper.deleteCarById01(list);
            return success();
        }
        catch (Exception e){
            e.printStackTrace();
            return failed(null,"操作异常，请确认");
        }
    }
    @ApiOperation(value = "根据司机直接启用", notes = "根据url的id来指定删除对象")
    //@RequiresPermissions("meterbasecar:delete")
    @PostMapping(value = "/enableByDriverNo")//String
    public RESTfulResult enableByCarNo(@RequestBody Map driverNo) {
        try {
            List<String> list = new ArrayList<>();
            list.add(driverNo.get("driverNo").toString());
            meterBaseDriverMapper.enableCarById01(list);
            return success();
        }
        catch (Exception e){
            e.printStackTrace();
            return failed(null,"操作异常，请确认");
        }
    }

    @ApiOperation(value = "获取该客商对应司机新信息", notes = "获取该客商对应车辆")
    //@RequiresPermissions("meterbasecar:view")
    @PostMapping(value = "/getCarBySup")
    public RESTfulResult getCarBySup(@RequestBody HashMap parma) {
        try {
            RESTfulResult rm = new RESTfulResult();
            rm.setCode("200");
            List<MeterBaseDriver> list = meterBaseDriverMapper.getDirverBySup(parma.get("customerSupplierNo").toString());
            rm.setData(list);
            return rm;
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }
}
